/*

 Prekladac PIC C LITE 

 O P T O Z A V O R A 
 
 Ivo Strasil (c) 2004 
 Licence GNU/GPL - Open Source

 ------------------------------------------

 PIC12F675

*/
//pripojeni knihoven
#include <pic.h>
#include "delay.h"

#define PORTBIT(adr,bit)	((unsigned)(&adr)*8+(bit))


static bit	OUT1   @ PORTBIT(GPIO,5);
static bit	OUT2   @ PORTBIT(GPIO,4);
static bit	IRLED  @ PORTBIT(GPIO,2);	
static bit	FIXMOD @ PORTBIT(GPIO,3);	

unsigned short adc_read(unsigned char channel)
{

		ADCON0 = (channel << 2) + 0x81;		// enable ADC, RC osc.
		DelayUs(20);
		GODONE = 1;
		while(GODONE)
			{NOP();};	// wait for conversion complete
		return ADRESH*256+ADRESL;	
}

void Delay(unsigned char dcnt) {
	//pro xtal 4MHzm, v dcnt je delka cekani x 20us
	while (--dcnt != 0) {
		DelayUs(15);
	}
}

void main() {
	//promenne hlavni smycky
	unsigned char cnt,mod;
	unsigned char okcnt1,okcnt2;
	unsigned short ad0l,ad1l,ad0h,ad1h,citlivost;
	
	//nastaveni I/O portu
	GPIO=0;
	WPU=0;			
	TRISIO=15-4;
	//nastaveni procesoru
	OPTION=143;
	//nastaveni AD prevodniku a jeho zapnuti
	ADCON0=1;
	ANSEL=16+4+2+1;
	//pockame chvilku
	DelayMs(100);
	while (1) {
		//nuluj citace
		okcnt1=0;okcnt2=0;
		//mer citlivost
		IRLED=0;
		TRISIO=15;
		DelayMs(1);
		citlivost=adc_read(2)/4;
		TRISIO=15-4;
		for (cnt=20;cnt<=45;cnt++) {
			
			//typ modulace
		/*	if (FIXMOD) {
				mod=30;
			} else {
				mod=cnt;
			}
		*/	mod=cnt;
			CLRWDT();
			//prepni LED
			IRLED=0;
			Delay(cnt);
			
			//vyhodnot
			//inp0
			ad0l=adc_read(1);
			//inp1
			ad1h=adc_read(0);
			//prepni LED
			IRLED=1;
			Delay(cnt);
		
			//vyhodnot
			ad0h=adc_read(1);
			ad1l=adc_read(0);

			//proved testovani hodnot
			if ((ad0h>citlivost)&&(ad0h-citlivost)>ad0l) {
				okcnt1++;
			}
			if ((ad1h>citlivost)&&(ad1h-citlivost)>ad1l) {
				okcnt2++;
			}			
		}
		if (FIXMOD) {
			OUT1=(okcnt1>20);
			OUT2=(okcnt2>20);
		} else {
			OUT1=(okcnt1<=20);
			OUT2=(okcnt2<=20);
			
		}	
		CLRWDT();
		
	}
}
